package de.hdm_stuttgart.mi.sd1.task1;

/**
 * Scrabble game scores.
 * <img src="doc-files/scrabble.jpg" alt="Scrabble" >
 *
 */
public class _5_Scrabble {
    /**
     * <p>Compute the Scrabble score of a given word.</p>
     *
     * <p>The Scrabble game awards scores for words using the usual the A-Z alphabet. Each character receives a case
     * independent score:</p>
     *
     *    <table class="goikTableDefaults">
     *        <caption>Letters and related score</caption>
     *        <tr>
     *            <th>Letters</th>
     *            <th>Score</th>
     *        </tr>
     *        <tr>
     *            <td>A, E, I, O, U, L, N, R, S, T</td>
     *            <td>1</td>
     *        </tr>
     *        <tr>
     *            <td>D, G</td>
     *            <td>2</td>
     *        </tr>
     *        <tr>
     *            <td>B, C, M, P</td>
     *            <td>3</td>
     *        </tr>
     *        <tr>
     *            <td>F, H, V, W, Y</td>
     *            <td>4</td>
     *        </tr>
     *        <tr>
     *            <td>K</td>
     *            <td>5</td>
     *        </tr>
     *        <tr>
     *            <td>J, X</td>
     *            <td>8</td>
     *        </tr>
     *        <tr>
     *            <td>Q, Z</td>
     *            <td>10</td>
     *        </tr>
     *    </table>
     *
     *  <p>A word's score equals the sum of its character scores. We calculate the score of
     *  <code>"CYPHERTEXT"</code> :</p>
     *
     * <img src="doc-files/scrabble.svg" alt="Scrabble">
     *
     * @param word A string or null
     * @return The word's score. Zero for empty string or <code>null</code>.
     */
    static public int getScore(final String word) {
        if (null == word) {
            return 0;
        } else {
            int score = 0;
            for (final char c: word.toUpperCase().toCharArray()) {
                score += getLetterScore(c);
            }
            return score;
        }
    }

    static private byte getLetterScore(final char c) {
        return switch (c) {
            case 'A', 'E', 'I', 'O', 'U', 'L', 'N', 'R', 'S', 'T' -> 1;
            case 'D', 'G' -> 2;
            case 'B', 'C', 'M', 'P' -> 3;
            case 'F', 'H', 'V', 'W', 'Y' -> 4;
            case 'K' -> 5;
            case 'J', 'X' -> 8;
            case 'Q', 'Z' -> 10;
            default -> 0;
        };
    }
    private _5_Scrabble(){/* Ignore me: My presence suppresses an otherwise visible default constructor's Javadoc */}
}
